package com.skr.mdm.license;

import de.schlichtherle.license.*;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.prefs.Preferences;

/**
 * @author nfq
 * @date 2021/09/01 17:16
 */
@Slf4j
public class LicenseVerify {

    /**
     * 安装License证书
     */
    public synchronized LicenseContent install(LicenseVerifyParam param) {
        LicenseContent result = null;
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // 安装证书
        try {
            LicenseManager licenseManager = LicenseManagerHolder.getInstance(initLicenseParam(param));
            licenseManager.uninstall();
            result = licenseManager.install(new File(param.getLicensePath()));
            LicenseCheckModel licenseCheckModel = (LicenseCheckModel) result.getExtra();
            log.info(MessageFormat.format("证书安装成功，证书有效期：{0} - {1} 授权用户数量：{2}", format.format(result.getNotBefore()), format.format(result.getNotAfter()), licenseCheckModel.getAllowUseNumber()));
        } catch (Exception e) {
            log.error("证书安装失败！", e);
        }
        return result;
    }

    /**
     * 校验License证书
     */
    public boolean verify() {
        LicenseManager licenseManager = LicenseManagerHolder.getInstance(null);
        if (licenseManager == null) {
            return false;
        }
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // 校验证书
        try {
            LicenseContent licenseContent = licenseManager.verify();
            LicenseCheckModel licenseCheckModel = (LicenseCheckModel) licenseContent.getExtra();
            log.info(MessageFormat.format("证书校验通过，证书有效期：{0} - {1} 授权用户数量:{2}", format.format(licenseContent.getNotBefore()), format.format(licenseContent.getNotAfter()), licenseCheckModel.getAllowUseNumber()));
            return true;
        } catch (Exception e) {
            log.error("证书校验失败！", e);
            return false;
        }
    }

    /**
     * 初始化证书生成参数
     *
     * @param param License校验类需要的参数
     * @return de.schlichtherle.license.LicenseParam
     */
    private LicenseParam initLicenseParam(LicenseVerifyParam param) {
        Preferences preferences = Preferences.userNodeForPackage(LicenseVerify.class);
        CipherParam cipherParam = new DefaultCipherParam(param.getStorePass());
        KeyStoreParam publicStoreParam = new CustomKeyStoreParam(LicenseVerify.class,
                param.getPublicKeysStorePath(),
                param.getPublicAlias(),
                param.getStorePass(),
                null);
        return new DefaultLicenseParam(param.getSubject(), preferences, publicStoreParam, cipherParam);
    }
}
